#include "ti86asm.inc"

.org _asm_exec_ram

;Source Code to Tic Tac Toe 86 for TI-86
;by Bradford Wilson

 call _clrScrn				;This clears the screen
 call _homeup				;This puts the cursor in the upper left

 ld a,84					;This loads a with 84 which is the ASCII number for the letter T
 call _putc					;This writes T on the screen
 ld a,73					;This loads a with 73 which is the ASCII number for the letter I
 call _putc					;This writes I on the screen
 ld a,67					;This loads a with 67 which is the ASCII number for the letter C
 call _putc					;This writes C on the screen
 ld a,84					;This loads a with 84 which is the ASCII number for the letter T
 call _putc					;This writes T on the screen
 ld a,65					;This loads a with 65 which is the ASCII number for the letter A
 call _putc					;This writes A on the screen
 ld a,67					;This loads a with 67 which is the ASCII number for the letter C
 call _putc					;This writes C on the screen
 ld a,84					;This loads a with 84 which is the ASCII number for the letter T
 call _putc					;This writes C on the screen
 ld a,79					;This loads a with 79 which is the ASCII number for the letter O
 call _putc					;This writes O on the screen
 ld a,69					;This loads a with 69 which is the ASCII number for the letter E
 call _putc					;This writes E on the screen

 call _pause				;This pauses the screen until enter is pushed
 call _clrScrn				;This clears the screen
 call _homeup				;This puts the cursor in the upper left

 ld a,66					;This loads a with 66 which is the ASCII number for the letter B
 call _putc					;This writes B on the screen
 ld a,89					;This loads a with 89 which is the ASCII number for the letter Y
 call _putc					;This writes Y on the screen
 ld a,3						;Stores 3 to register a
 ld (_curCol),a				;Puts the cursor to the column number stored in a(3)
 ld a,66					;This loads a with 66 which is the ASCII number for the letter B
 call _putc					;This writes B on the screen
 ld a,82					;This loads a with 82 which is the ASCII number for the letter R
 call _putc					;This writes R on the screen
 ld a,65					;This loads a with 65 which is the ASCII number for the letter A
 call _putc					;This writes A on the screen
 ld a,68					;This loads a with 68 which is the ASCII number for the letter D
 call _putc					;This writes D on the screen
 ld a,70					;This loads a with 70 which is the ASCII number for the letter F
 call _putc					;This writes F on the screen
 ld a,79					;This loads a with 79 which is the ASCII number for the letter O
 call _putc					;This writes O on the screen
 ld a,82					;This loads a with 82 which is the ASCII number for the letter R
 call _putc					;This writes R on the screen
 ld a,68					;This loads a with 68 which is the ASCII number for the letter D
 call _putc					;This writes D on the screen
 ld a,12					;Stores 12 to register a
 ld (_curCol),a				;Puts the cursor to the column number stored in a(12)
 ld a,87					;This loads a with 87 which is the ASCII number for the letter W
 call _putc					;This writes W on the screen
 ld a,73					;This loads a with 73 which is the ASCII number for the letter I
 call _putc					;This writes I on the screen
 ld a,76					;This loads a with 76 which is the ASCII number for the letter L
 call _putc					;This writes L on the screen
 ld a,83					;This loads a with 83 which is the ASCII number for the letter S
 call _putc					;This writes S on the screen
 ld a,79					;This loads a with 79 which is the ASCII number for the letter O
 call _putc					;This writes O on the screen
 ld a,78					;This loads a with 78 which is the ASCII number for the letter N
 call _putc					;This writes N on the screen


 call _pause				;This pauses the calculator until enter is pushed
 call _clrScrn				;This clears the screen
 call _homeup				;This puts the cursor in the upper left

 ld a,85					;This loads a with 85 which is the ASCII number for the letter U
 call _putc					;This writes U on the screen
 ld a,83					;This loads a with 83 which is the ASCII number for the letter S
 call _putc					;This writes S on the screen
 ld a,69					;This loads a with 69 which is the ASCII number for the letter E
 call _putc					;This writes E on the screen
 ld a,4						;Stores 4 to register a
 ld (_curCol),a				;Puts the cursor to the column number stored in a(4)
 ld a,84					;This loads a with 84 which is the ASCII number for the letter T
 call _putc					;This writes T on the screen
 ld a,72					;This loads a with 72 which is the ASCII number for the letter H
 call _putc					;This writes H on the screen
 ld a,69					;This loads a with 69 which is the ASCII number for the letter E
 call _putc					;This writes E on the screen
 ld a,8						;Stores 8 to register a
 ld (_curCol),a				;Puts the cursor to the column number stored in a(8)
 ld a,78					;This loads a with 78 which is the ASCII number for the letter N
 call _putc					;This writes N on the screen
 ld a,85					;This loads a with 85 which is the ASCII number for the letter U
 call _putc					;This writes U on the screen
 ld a,77					;This loads a with 77 which is the ASCII number for the letter M
 call _putc					;This writes M on the screen
 ld a,66					;This loads a with 66 which is the ASCII number for the letter B
 call _putc					;This writes B on the screen
 ld a,69					;This loads a with 69 which is the ASCII number for the letter E
 call _putc					;This writes E on the screen
 ld a,82					;This loads a with 82 which is the ASCII number for the letter R
 call _putc					;This writes R on the screen
 ld a,15					;Stores 15 to register a
 ld (_curCol),a				;Puts the cursor to the column number stored in a(15)
 ld a,80					;This loads a with 80 which is the ASCII number for the letter P
 call _putc					;This writes P on the screen
 ld a,65					;This loads a with 65 which is the ASCII number for the letter A
 call _putc					;This writes A on the screen
 ld a,68					;This loads a with 68 which is the ASCII number for the letter D
 call _putc					;This writes D on the screen
 ld a,1						;Stores 1 to register a
 ld (_curRow),a				;Puts the cursor to the row number stored in a(1)
 ld a,0						;Stores 0 to register a
 ld (_curCol),a				;Puts the cursor to the column number stored in a(0)
 ld a,84					;This loads a with 84 which is the ASCII number for the letter T
 call _putc					;This writes T on the screen
 ld a,79					;This loads a with 79 which is the ASCII number for the letter O
 call _putc					;This writes O on the screen
 ld a,3						;Stores 3 to register a
 ld (_curCol),a				;Puts the cursor to the column number store in a(3)
 ld a,80					;This loads a with 80 which is the ASCII number for the letter P
 call _putc					;This writes P on the screen
 ld a,76					;This loads a with 76 which is the ASCII number for the letter L
 call _putc					;This writes L on the screen
 ld a,65					;This loads a with 65 which is the ASCII number for the letter A
 call _putc					;This writes A on the screen
 ld a,67					;This loads a with 67 which is the ASCII number for the letter C
 call _putc					;This writes C on the screen
 ld a,69					;This loads a with 69 which is the ASCII number for the letter E
 call _putc					;This writes E on the screen
 ld a,9						;Stores 9 to register a
 ld (_curCol),a				;Puts the cursor to the column number store in a(19)
 ld a,88					;This loads a with 88 which is the ASCII number for the letter X
 call _putc					;This writes X on the screen
 ld a,11					;Stores 11 to register a
 ld (_curCol),a				;Puts the cursor to the column number store in a(11)
 ld a,79					;This loads a with 79 which is the ASCII number for the letter O
 call _putc					;This writes O on the screen
 ld a,82					;This loads a with 82 which is the ASCII number for the letter R
 call _putc					;This writes R on the screen
 ld a,14					;Stores 14 to register a
 ld (_curCol),a				;Puts the cursor to the column number store in a(14)
 ld a,79					;This loads a with 79 which is the ASCII number for the letter O
 call _putc					;This writes Y on the screen

 call _pause				;This pauses the calculator until enter is pushed
 call _clrScrn				;This clears the screen
 call _homeup				;This puts the cursor in the upper left

 ld hl,grid1				;This puts the picture stored in grid1 into register hl
 ld de,$0000				;This stores the hexadecimal ($) number 0000 to register de
							;This number will be broken into two parts...
							;The first two (00) tell the row number (in this case, row 1)
							;The second two (00) tell the column (column 1)
 call GridPutSprite			;This runs GridPutSprite
 ld hl,grid2				;This puts the picture stored in grid2 into register hl
 ld de,$0001				;This stores 0001 to register de (row 1, column 2)
 call GridPutSprite			;This runs GridPutSprite
 ld hl,grid3				;This puts the picture stored in grid3 into register hl
 ld de,$0002				;This stores 0002 to register de (row 1, column 3)
 call GridPutSprite			;This runs GridPutSprite
 ld hl,grid4				;This puts the picture stored in grid4 into register hl
 ld de,$0100				;This stores 0100 to register de (row 2, column 1)
 call GridPutSprite			;This runs GridPutSprite
 ld hl,grid5				;This puts the picture stored in grid5 into register hl
 ld de,$0101				;This stores 0101 to register de (row 2, column 2)
 call GridPutSprite			;This runs GridPutSprite
 ld hl,grid6				;This puts the picture stored in grid6 into register hl
 ld de,$0102				;This stores 0102 to register de (row 2, column 3)
 call GridPutSprite			;This runs GridPutSprite
 ld hl,grid7				;This puts the picture stored in grid7 into register hl
 ld de,$0200				;This stores 0200 to register de (row 3, column 1)
 call GridPutSprite			;This runs GridPutSprite
 ld hl,grid8				;This puts the picture stored in grid8 into register hl
 ld de,$0201				;This stores 0201 to register de (row 3, column 2)
 call GridPutSprite			;This runs GridPutSprite
 ld hl,grid9				;This puts the picture stored in grid9 into register hl
 ld de,$0202				;This stores 0202 to register de (row 3, column 3)
 call GridPutSprite			;This runs GridPutSprite

xturn:						;
 ld a,0						;
 ld (_curCol),a				;
 ld a,5						;
 ld (_curRow),a				;
 ld a,88					;
 call _putc					;
 ld a,39					;
 call _putc					;
 ld a,83					;
 call _putc					;
 ld a,4						;
 ld (_curCol),a				;
 ld a,84					;
 call _putc					;
 ld a,85					;
 call _putc					;
 ld a,82					;
 call _putc					;
 ld a,78					;
 call _putc					;
 call _getkey				;
 cp k1						;
 jp z,xkey1 				;

 cp k2						;
 jp z,xkey2					;

 cp k3						;
 jp z,xkey3					;

 cp k4						;
 jp z,xkey4					;

 cp k5						;
 jp z,xkey5					;

 cp k6						;
 jp z,xkey6					;

 cp k7						;
 jp z,xkey7					;

 cp k8						;
 jp z,xkey8					;

 cp k9						;
 jp z,xkey9					;

xkey1:						;
 ld hl,x1					;
 ld de,$0200				;
 call GridPutSprite			;
 jp oturn					;

xkey2:						;
 ld hl,x2					;
 ld de,$0201				;
 call GridPutSprite			;
 jp oturn					;

xkey3:						;
 ld hl,x3					;
 ld de,$0202				;
 call GridPutSprite			;
 jp oturn					;

xkey4:						;
 ld hl,x4					;
 ld de,$0100				;
 call GridPutSprite			;
 jp oturn					;

xkey5:						;
 ld hl,x5					;
 ld de,$0101				;
 call GridPutSprite			;
 jp oturn					;

xkey6:						;
 ld hl,x6					;
 ld de,$0102				;
 call GridPutSprite			;
 jp oturn					;

xkey7:						;
 ld hl,x7					;
 ld de,$0000				;
 call GridPutSprite			;
 jp oturn					;

xkey8:						;
 ld hl,x8					;
 ld de,$0001				;
 call GridPutSprite			;
 jp oturn					;

xkey9:						;
 ld hl,x9					;
 ld de,$0002				;
 call GridPutSprite			;
 jp oturn					;

oturn:						;
 ld a,0						;
 ld (_curCol),a				;
 ld a,5						;
 ld (_curRow),a				;
 ld a,79					;
 call _putc					;
 ld a,39					;
 call _putc					;
 ld a,83					;
 call _putc					;
 ld a,4						;
 ld (_curCol),a				;
 ld a,84					;
 call _putc					;
 ld a,85					;
 call _putc					;
 ld a,82					;
 call _putc					;
 ld a,78					;
 call _putc					;
 call _getkey				;
 cp k1						;
 jp z,okey1 				;

 cp k2						;
 jp z,okey2					;

 cp k3						;
 jp z,okey3					;

 cp k4						;
 jp z,okey4					;

 cp k5						;
 jp z,okey5					;

 cp k6						;
 jp z,okey6					;

 cp k7						;
 jp z,okey7					;

 cp k8						;
 jp z,okey8					;

 cp k9						;
 jp z,okey9					;

okey1:						;
 ld hl,o1					;
 ld de,$0200				;
 call GridPutSprite			;
 jp xturn2					;

okey2:						;
 ld hl,o2					;
 ld de,$0201				;
 call GridPutSprite			;
 jp xturn2					;

okey3:						;
 ld hl,o3					;
 ld de,$0202				;
 call GridPutSprite			;
 jp xturn2					;

okey4:						;
 ld hl,o4					;
 ld de,$0100				;
 call GridPutSprite			;
 jp xturn2					;

okey5:						;
 ld hl,o5					;
 ld de,$0101				;
 call GridPutSprite			;
 jp xturn2					;

okey6:						;
 ld hl,o6					;
 ld de,$0102				;
 call GridPutSprite			;
 jp xturn2					;

okey7:						;
 ld hl,o7					;
 ld de,$0000				;
 call GridPutSprite			;
 jp xturn2					;

okey8:						;
 ld hl,o8					;
 ld de,$0001				;
 call GridPutSprite			;
 jp xturn2					;

okey9:						;
 ld hl,o9					;
 ld de,$0002				;
 call GridPutSprite			;
 jp xturn2					;


xturn2:						;
  ld a,0					;
 ld (_curCol),a				;
 ld a,5						;
 ld (_curRow),a				;
 ld a,88					;
 call _putc					;
 ld a,39					;
 call _putc					;
 ld a,83					;
 call _putc					;
 ld a,4						;
 ld (_curCol),a				;
 ld a,84					;
 call _putc					;
 ld a,85					;
 call _putc					;
 ld a,82					;
 call _putc					;
 ld a,78					;
 call _putc					;
 call _getkey				;
 cp k1						;
 jp z,x2key1 				;

 cp k2						;
 jp z,x2key2				;

 cp k3						;
 jp z,x2key3				;

 cp k4						;
 jp z,x2key4				;

 cp k5						;
 jp z,x2key5				;

 cp k6		
 jp z,x2key6				;

 cp k7						;
 jp z,x2key7				;

 cp k8						;
 jp z,x2key8				;

 cp k9						;
 jp z,x2key9				;

x2key1:						;
 ld hl,x1					;
 ld de,$0200				;
 call GridPutSprite			;
 jp oturn2					;

x2key2:						;
 ld hl,x2					;
 ld de,$0201				;
 call GridPutSprite			;
 jp oturn2					;

x2key3:						;
 ld hl,x3					;
 ld de,$0202				;
 call GridPutSprite			;
 jp oturn2					;

x2key4:						;
 ld hl,x4					;
 ld de,$0100				;
 call GridPutSprite			;
 jp oturn2					;

x2key5:						;
 ld hl,x5					;
 ld de,$0101				;
 call GridPutSprite			;
 jp oturn2					;

x2key6:						;
 ld hl,x6					;
 ld de,$0102				;
 call GridPutSprite			;
 jp oturn2					;

x2key7:						;
 ld hl,x7					;
 ld de,$0000				;
 call GridPutSprite			;
 jp oturn2					;

x2key8:						;
 ld hl,x8					;
 ld de,$0001				;
 call GridPutSprite			;
 jp oturn2					;

x2key9:						;
 ld hl,x9					;
 ld de,$0002				;
 call GridPutSprite			;
 jp oturn2					;

oturn2:						;
 ld a,0						;
 ld (_curCol),a				;
 ld a,5						;
 ld (_curRow),a				;
 ld a,79					;
 call _putc					;
 ld a,39					;
 call _putc					;
 ld a,83					;
 call _putc					;
 ld a,4						;
 ld (_curCol),a				;
 ld a,84					;
 call _putc					;
 ld a,85					;
 call _putc					;
 ld a,82					;
 call _putc					;
 ld a,78					;
 call _putc					;
 call _getkey				;
 cp k1						;
 jp z,o2key1 				;

 cp k2						;
 jp z,o2key2				;

 cp k3						;
 jp z,o2key3				;

 cp k4						;
 jp z,o2key4				;

 cp k5						;
 jp z,o2key5				;

 cp k6						;
 jp z,o2key6				;

 cp k7						;
 jp z,o2key7				;

 cp k8						;
 jp z,o2key8				;

 cp k9						;
 jp z,o2key9				;

o2key1:						;
 ld hl,o1					;
 ld de,$0200				;
 call GridPutSprite			;
 jp xturn3					;

o2key2:						;
 ld hl,o2					;
 ld de,$0201				;
 call GridPutSprite			;
 jp xturn3					;

o2key3:						;
 ld hl,o3					;
 ld de,$0202				;
 call GridPutSprite			;
 jp xturn3					;

o2key4:						;
 ld hl,o4					;
 ld de,$0100				;
 call GridPutSprite			;
 jp xturn3					;

o2key5:						;
 ld hl,o5					;
 ld de,$0101				;
 call GridPutSprite			;
 jp xturn3					;

o2key6:						;
 ld hl,o6					;
 ld de,$0102				;
 call GridPutSprite			;
 jp xturn3					;

o2key7:						;
 ld hl,o7					;
 ld de,$0000				;
 call GridPutSprite			;
 jp xturn3					;

o2key8:						;
 ld hl,o8					;
 ld de,$0001				;
 call GridPutSprite			;
 jp xturn3					;

o2key9:						;
 ld hl,o9					;
 ld de,$0002				;
 call GridPutSprite			;
 jp xturn3					;

xturn3:						;
  ld a,0					;
 ld (_curCol),a				;
 ld a,5						;
 ld (_curRow),a				;
 ld a,88					;
 call _putc					;
 ld a,39					;
 call _putc					;
 ld a,83					;
 call _putc					;
 ld a,4						;
 ld (_curCol),a				;
 ld a,84					;
 call _putc					;
 ld a,85					;
 call _putc					;
 ld a,82					;
 call _putc					;
 ld a,78					;
 call _putc					;
 call _getkey				;
 cp k1						;
 jp z,x3key1				;

 cp k2						;
 jp z,x3key2				;

 cp k3						;
 jp z,x3key3				;

 cp k4						;
 jp z,x3key4				;

 cp k5						;
 jp z,x3key5				;

 cp k6						;
 jp z,x3key6				;

 cp k7						;
 jp z,x3key7				;

 cp k8						;
 jp z,x3key8				;

 cp k9						;
 jp z,x3key9				;

x3key1:						;
 ld hl,x1					;
 ld de,$0200				;
 call GridPutSprite			;
 jp oturn3					;

x3key2:						;
 ld hl,x2					;
 ld de,$0201				;
 call GridPutSprite			;
 jp oturn3					;

x3key3:						;
 ld hl,x3					;
 ld de,$0202				;
 call GridPutSprite			;
 jp oturn3					;

x3key4:						;
 ld hl,x4					;
 ld de,$0100				;
 call GridPutSprite			;
 jp oturn3					;

x3key5:						;
 ld hl,x5					;
 ld de,$0101				;
 call GridPutSprite			;
 jp oturn3					;

x3key6:						;
 ld hl,x6					;
 ld de,$0102				;
 call GridPutSprite			;
 jp oturn3					;

x3key7:						;
 ld hl,x7					;
 ld de,$0000				;
 call GridPutSprite			;
 jp oturn3					;

x3key8:						;
 ld hl,x8					;
 ld de,$0001				;
 call GridPutSprite			;
 jp oturn3					;

x3key9:						;
 ld hl,x9					;
 ld de,$0002				;
 call GridPutSprite			;
 jp oturn3					;

oturn3:						;
 ld a,0						;
 ld (_curCol),a				;
 ld a,5						;
 ld (_curRow),a				;
 ld a,79					;
 call _putc					;
 ld a,39					;

 ld a,83					;
 call _putc					;
 ld a,4						;
 ld (_curCol),a				;
 ld a,84					;
 call _putc					;
 ld a,85					;
 call _putc					;
 ld a,82					;
 call _putc					;
 ld a,78					;
 call _putc					;
 call _getkey				;
 cp k1						;
 jp z,o3key1 				;

 cp k2						;
 jp z,o3key2				;

 cp k3						;
 jp z,o3key3				;

 cp k4						;
 jp z,o3key4				;

 cp k5						;
 jp z,o3key5				;

 cp k6						;
 jp z,o3key6				;

 cp k7						;
 jp z,o3key7				;

 cp k8						;
 jp z,o3key8				;

 cp k9						;
 jp z,o3key9				;

o3key1:						;
 ld hl,o1					;
 ld de,$0200				;
 call GridPutSprite			;
 jp xturn4					;

o3key2:						;
 ld hl,o2					;
 ld de,$0201				;
 call GridPutSprite			;
 jp xturn4					;

o3key3:						;
 ld hl,o3					;
 ld de,$0202				;
 call GridPutSprite			;
 jp xturn4					;

o3key4:						;
 ld hl,o4					;
 ld de,$0100				;
 call GridPutSprite			;
 jp xturn4					;

o3key5:						;
 ld hl,o5					;
 ld de,$0101				;
 call GridPutSprite			;
 jp xturn4					;

o3key6:						;
 ld hl,o6					;
 ld de,$0102				;
 call GridPutSprite			;
 jp xturn4					;

o3key7:						;
 ld hl,o7					;
 ld de,$0000				;
 call GridPutSprite			;
 jp xturn4					;

o3key8:						;
 ld hl,o8					;
 ld de,$0001				;
 call GridPutSprite			;
 jp xturn4					;

o3key9:						;
 ld hl,o9					;
 ld de,$0002				;
 call GridPutSprite			;
 jp xturn4					;

xturn4:						;
 ld a,0						;
 ld (_curCol),a				;
 ld a,5						;
 ld (_curRow),a				;
 ld a,88					;
 call _putc					;
 ld a,39					;
 call _putc					;
 ld a,83					;
 call _putc					;
 ld a,4						;
 ld (_curCol),a				;
 ld a,84					;
 call _putc					;
 ld a,85					;
 call _putc					;
 ld a,82					;
 call _putc					;
 ld a,78					;
 call _putc					;
 call _getkey				;
 cp k1						;
 jp z,x4key1 				;

 cp k2						;
 jp z,x4key2				;

 cp k3						;
 jp z,x4key3				;

 cp k4						;
 jp z,x4key4				;

 cp k5						;
 jp z,x4key5				;

 cp k6						;
 jp z,x4key6				;

 cp k7						;
 jp z,x4key7				;

 cp k8						;
 jp z,x4key8				;

 cp k9						;
 jp z,x4key9				;

x4key1:						;
 ld hl,x1					;
 ld de,$0200				;
 call GridPutSprite			;
 jp oturn4					;

x4key2:						;
 ld hl,x2					;
 ld de,$0201				;
 call GridPutSprite			;
 jp oturn4					;

x4key3:						;
 ld hl,x3					;
 ld de,$0202				;
 call GridPutSprite			;
 jp oturn4					;

x4key4:						;
 ld hl,x4					;
 ld de,$0100				;
 call GridPutSprite			;
 jp oturn4					;

x4key5:						;
 ld hl,x5					;
 ld de,$0101				;
 call GridPutSprite			;
 jp oturn4					;

x4key6:						;
 ld hl,x6					;
 ld de,$0102				;
 call GridPutSprite			;
 jp oturn4					;

x4key7:						;
 ld hl,x7					;
 ld de,$0000				;
 call GridPutSprite			;
 jp oturn4					;

x4key8:						;
 ld hl,x8					;
 ld de,$0001				;
 call GridPutSprite			;
 jp oturn4					;

x4key9:						;
 ld hl,x9					;
 ld de,$0002				;
 call GridPutSprite			;
 jp oturn4					;

oturn4:						;
 ld a,0						;
 ld (_curCol),a				;
 ld a,5						;
 ld (_curRow),a				;
 ld a,79					;
 call _putc					;
 ld a,39					;
 call _putc					;
 ld a,83					;
 call _putc					;
 ld a,4						;
 ld (_curCol),a				;
 ld a,84					;
 call _putc					;
 ld a,85					;
 call _putc					;
 ld a,82					;
 call _putc					;
 ld a,78					;
 call _putc					;
 call _getkey				;

 cp k1						;
 jp z,o4key1 				;

 cp k2		 				;
 jp z,o4key2 				;

 cp k3		 				;
 jp z,o4key3 				;

 cp k4		 				;
 jp z,o4key4 				;

 cp k5		 				;
 jp z,o4key5 				;

 cp k6		 				;
 jp z,o4key6 				;

 cp k7		 				;
 jp z,o4key7 				;

 cp k8		 				;
 jp z,o4key8 				;

 cp k9		 				;
 jp z,o4key9 				;

o4key1: 					;
 ld hl,o1 					;
 ld de,$0200 				;
 call GridPutSprite 		;
 jp xturn5 					;

o4key2: 					;
 ld hl,o2 					;
 ld de,$0201 				;
 call GridPutSprite 		;
 jp xturn5 					;

o4key3: 					;
 ld hl,o3 					;
 ld de,$0202 				;
 call GridPutSprite 		;
 jp xturn5 					;

o4key4: 					;
 ld hl,o4 					;
 ld de,$0100 				;
 call GridPutSprite 		;
 jp xturn5 					;

o4key5: 					;
 ld hl,o5 					;
 ld de,$0101 				;
 call GridPutSprite 		;
 jp xturn5 					;

o4key6: 					;
 ld hl,o6 					;
 ld de,$0102 				;
 call GridPutSprite 		;
 jp xturn5 					;

o4key7: 					;
 ld hl,o7 					;
 ld de,$0000 				;
 call GridPutSprite 		;
 jp xturn5 					;

o4key8: 					;
 ld hl,o8 					;
 ld de,$0001 				;
 call GridPutSprite 		;
 jp xturn5 					;

o4key9: 					;
 ld hl,o9 					;
 ld de,$0002 				;
 call GridPutSprite 		;
 jp xturn5 					;

xturn5: 					;
 ld a,0						;
 ld (_curCol),a				;
 ld a,5						;
 ld (_curRow),a				;
 ld a,88					;
 call _putc					;
 ld a,39					;
 call _putc					;
 ld a,83					;
 call _putc					;
 ld a,4						;
 ld (_curCol),a				;
 ld a,84					;
 call _putc					;
 ld a,85					;
 call _putc					;
 ld a,82					;
 call _putc					;
 ld a,78					;
 call _putc					;
 call _getkey				;
 cp k1						;
 jp z,x5key1 				;

 cp k2						;
 jp z,x5key2				;

 cp k3						;
 jp z,x5key3				;

 cp k4						;
 jp z,x5key4				;

 cp k5						;
 jp z,x5key5				;

 cp k6						;
 jp z,x5key6				;

 cp k7						;
 jp z,x5key7				;

 cp k8						;
 jp z,x5key8				;

 cp k9						;
 jp z,x5key9				;

x5key1:						;
 ld hl,x1					;
 ld de,$0200				;
 call GridPutSprite			;
 call _pause				;
 call _clrScrn				;
 call _homeup				;
 ret						;

x5key2:						;
 ld hl,x2					;
 ld de,$0201				;
 call GridPutSprite			;
 call _pause				;
 call _clrScrn				;
 call _homeup				;
 ret						;

x5key3:						;
 ld hl,x3					;
 ld de,$0202				;
 call GridPutSprite			;
 call _pause				;
 call _clrScrn				;
 call _homeup				;
 ret						;

x5key4:						;
 ld hl,x4					;
 ld de,$0100				;
 call GridPutSprite			;
 call _pause				;
 call _clrScrn				;
 call _homeup				;
 ret						;

x5key5:						;
 ld hl,x5					;
 ld de,$0101				;
 call GridPutSprite			;
 call _pause				;
 call _clrScrn				;
 call _homeup				;
 ret						;

x5key6:						;
 ld hl,x6					;
 ld de,$0102				;
 call GridPutSprite			;
 call _pause				;
 call _clrScrn				;
 call _homeup				;
 ret						;

x5key7:						;
 ld hl,x7					;
 ld de,$0000				;
 call GridPutSprite			;
 call _pause				;
 call _clrScrn				;
 call _homeup				;
 ret						;

x5key8:						;
 ld hl,x8					;
 ld de,$0001				;
 call GridPutSprite			;
 call _pause				;
 call _clrScrn				;
 call _homeup				;
 ret						;

x5key9:						;
 ld hl,x9					;
 ld de,$0002				;
 call GridPutSprite			;
 call _pause				;
 call _clrScrn				;
 call _homeup				;
 ret						;


GridPutSprite:				;This is the label that is called to draw the picture (a sprite is also a picture)
  push hl         			;This pushes register hl onto the stack
  pop ix                 	;This pops whats on the stack (formerly what was in hl) into register ix
  srl d                  	;de = (128 * y) + x
  rra                    	;carry flag -< msb of a
  and $80                	;a is either $00 or $80   
  or e                   	;add x offset (remember x <= 15)
  ld e,a                 	;de = (128 * y) + (x * 8)
  ld hl,$fc00            	;This loads hl with the video memory
  add hl,de              	;This loads hl with the video memory + offset
  ld b,8                 	;This sets the loop counter to 8
  ld de,16               	;This is because the screen is 16 bytes wide
GPS_Loop:					;This is the loop part
  ld a,(ix + 0)          	;This gets the byte from sprite
  ld (hl),a              	;This puts the byte on screen
  inc ix                 	;This moves to next byte in sprite
  add hl,de              	;This moves to next line on screen
  djnz GPS_Loop          	;This decreases the loop counter so it will loop until the sprite is drawn
  ret                    	;This returns to where in the program it was

grid1:						;
.db %00000001				;
.db %00000001				;
.db %00000001				;
.db %00000001				;
.db %00000001				;
.db %00000001				;
.db %00000001				;
.db %11111111				;

grid2:						;
.db %10000001				;
.db %10000001				;
.db %10000001				;
.db %10000001				;
.db %10000001				;
.db %10000001				;
.db %10000001				;
.db %11111111				;

grid3:						;
.db %10000000				;
.db %10000000				;
.db %10000000				;
.db %10000000				;
.db %10000000				;
.db %10000000				;
.db %10000000				;
.db %11111111				;

grid4:						;
.db %11111111				;
.db %00000001				;
.db %00000001				;
.db %00000001				;
.db %00000001				;
.db %00000001				;
.db %00000001				;
.db %11111111				;

grid5:						;
.db %11111111				;
.db %10000001				;
.db %10000001				;
.db %10000001				;
.db %10000001				;
.db %10000001				;
.db %10000001				;
.db %11111111				;

grid6:						;
.db %11111111				;
.db %10000000				;
.db %10000000				;
.db %10000000				;
.db %10000000				;
.db %10000000				;
.db %10000000				;
.db %11111111				;

grid7:						;
.db %11111111				;
.db %00000001				;
.db %00000001				;
.db %00000001				;
.db %00000001				;
.db %00000001				;
.db %00000001				;
.db %00000001				;

grid8:						;
.db %11111111				;
.db %10000001				;
.db %10000001				;
.db %10000001				;
.db %10000001				;
.db %10000001				;
.db %10000001				;
.db %10000001				;

grid9:						;
.db %11111111				;
.db %10000000				;
.db %10000000				;
.db %10000000				;
.db %10000000				;
.db %10000000				;
.db %10000000				;
.db %10000000				;

x7:							;
.db %00000001				;
.db %01000011				;
.db %00100101				;
.db %00011001				;
.db %00011001				;
.db %00100101				;
.db %01000011				;
.db %11111111				;

x8:							;
.db %10000001				;
.db %11000011				;
.db %10100101				;
.db %10011001				;
.db %10011001				;
.db %10100101				;
.db %11000011				;
.db %11111111				;

x9:							;
.db %10000000				;
.db %11000010				;
.db %10100100				;
.db %10011000				;
.db %10011000				;
.db %10100100				;
.db %11000010				;
.db %11111111				;

x4:							;
.db %11111111				;
.db %01000011				;
.db %00100101				;
.db %00011001				;
.db %00011001				;
.db %00100101				;
.db %01000011				;
.db %11111111				;

x5:							;
.db %11111111				;
.db %11000011				;
.db %10100101				;
.db %10011001				;
.db %10011001				;
.db %10100101				;
.db %11000011				;
.db %11111111				;

x6:							;
.db %11111111				;
.db %11000010				;
.db %10100100				;
.db %10011000				;
.db %10011000				;
.db %10100100				;
.db %11000010				;
.db %11111111				;

x1:							;
.db %11111111				;
.db %01000011				;
.db %00100101				;
.db %00011001				;
.db %00011001				;
.db %00100101				;
.db %01000011				;
.db %00000001				;

x2:							;
.db %11111111				;
.db %11000011				;
.db %10100101				;
.db %10011001				;
.db %10011001				;
.db %10100101				;
.db %11000011				;
.db %10000001				;

x3:							;
.db %11111111				;
.db %11000010				;
.db %10100100				;
.db %10011000				;
.db %10011000				;
.db %10100100				;
.db %11000010				;
.db %10000000				;

o7:							;
.db %00000001				;
.db %00000001				;
.db %00111101				;
.db %00100101				;
.db %00100101				;
.db %00111101				;
.db %00000001				;
.db %11111111				;

o8:							;
.db %10000001				;
.db %10000001				;
.db %10111101				;
.db %10100101				;
.db %10100101				;
.db %10111101				;
.db %10000001				;
.db %11111111				;

o9:							;
.db %10000000				;
.db %10000000				;
.db %10111100				;
.db %10100100				;
.db %10100100				;
.db %10111100				;
.db %10000000				;
.db %11111111				;

o4:							;
.db %11111111				;
.db %00000001				;
.db %00111101				;
.db %00100101				;
.db %00100101				;
.db %00111101				;
.db %00000001				;
.db %11111111				;

o5:							;
.db %11111111				;
.db %10000001				;
.db %10111101				;
.db %10100101				;
.db %10100101				;
.db %10111101				;
.db %10000001				;
.db %11111111				;

o6:							;
.db %11111111				;
.db %10000000				;
.db %10111100				;
.db %10100100				;
.db %10100100				;
.db %10111100				;
.db %10000000				;
.db %11111111				;

o1:							;
.db %11111111				;
.db %00000001				;
.db %00111101				;
.db %00100101				;
.db %00100101				;
.db %00111101				;
.db %00000001				;
.db %00000001				;

o2:							;
.db %11111111				;
.db %10000001				;
.db %10111101				;
.db %10100101				;
.db %10100101				;
.db %10111101				;
.db %10000001				;
.db %10000001				;

o3:							;
.db %11111111				;
.db %10000000				;
.db %10111100				;
.db %10100100				;
.db %10100100				;
.db %10111100				;
.db %10000000				;
.db %10000000				;

.end						;This tells the assembler that there is no more code after this